
#ifndef DOSBOX_HADROPL_H
#define DOSBOX_HARDOPL_H

#include "adlib.h"
#include "dosbox.h"
#if defined (WIN32)
#include <windows.h>
#endif

struct IRealChipBase;
struct IGimic;
struct IRealChip;

namespace HARDOPL {

struct Chip {
	Chip();
	~Chip();
	void Init();
	void Shutdown();

	bool hardActive;
	bool opl3Active;
	HMODULE handle;
	IRealChipBase *chipBase;
	IGimic *gimic;
	IRealChip *realChip;

	Bit32u WriteAddr( Bit32u port, Bit8u val );
	void WriteReg(Bit32u reg, Bit8u val );
};

struct Handler : public Adlib::Handler {
	HARDOPL::Chip chip;
	virtual Bit32u WriteAddr( Bit32u port, Bit8u val );
	virtual void WriteReg( Bit32u addr, Bit8u val );
	virtual void Generate( MixerChannel* chan, Bitu samples );
	virtual void Init( Bitu rate );
};

};		//Namespace

#endif
